/* (C) Peter Mueller / sinelabore.com */
/* Command line options: -U toggle.cfg -p CADIFRA -o pwr pwr.cdd   */
/* This file is generated from pwr.cdd - do not edit manually  */
/* Generated on: Thu Jan 01 23:23:42 CET 2015 / version 3.6.7 */


#include <stdint.h>
#include <msp430.h>
#include "pwr_ext.h"
#include "pwr.h"
#include "../lib/timer.h"
#include "../lib/adc10.h"

extern uint8_t timerId2;
extern FIFO_T buf2;

void  pwr(PWR_INSTANCEDATA_T *instanceVar, PWR_EVENT_T msg){
	
	/*execute entry code of default state once to init machine */
	if(instanceVar->s1Entry==1U){
		timerId2 = timerCreate(&buf2, evPwrTimeout,true);
		initADC10();
		timerStart(timerId2,T2S);
		retriggerADC10();
		

		instanceVar->s1Entry=0U;
	}


	switch (instanceVar->stateVar) {

		case S1:
			if(msg==(PWR_EVENT_T)evPwrTimeout){
				/* Transition from S1 to S1 */

				/* Action code for transition  */
				P1OUT ^= BIT2;


				/* OnEntry code of state S1 */
				retriggerADC10();

				/* adjust state variables  */
				instanceVar->stateVar = S1;
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case S1  */

		default:
			/* Intentionally left blank */
		break;
	} /* end switch stateVar_root */
}

/* Implementation of the reset machine function */
void pwrResetMachine(PWR_INSTANCEDATA_T *instanceVar){
	instanceVar->s1Entry = 1U;
	instanceVar->stateVar = S1;
	
}

// Helper(s) to find out if the machine is in a certain state

uint8_t pwrIsInS1(PWR_INSTANCEDATA_T *instanceVar){
	return(((instanceVar->stateVar== S1)) ? (1U) : (0U));
}


// Helper to get id of innermost active state
PWR_STATES_T pwrGetInnermostActiveState(PWR_INSTANCEDATA_T *instanceVar){
	if(pwrIsInS1(instanceVar)){
		return S1;
	}else{
		return __PWR_LAST_STATE__;
	}
}

